<?php
/* This file has been auto-generated. Do not edit this file directly. */

abstract class Sabai_Addon_System_Model_Base_RoleGateway extends SabaiFramework_Model_Gateway
{
    public function getName()
    {
        return 'system_role';
    }

    public function getFields()
    {
        return array('role_name' => SabaiFramework_Model::KEY_TYPE_VARCHAR, 'role_title' => SabaiFramework_Model::KEY_TYPE_VARCHAR, 'role_permissions' => SabaiFramework_Model::KEY_TYPE_TEXT, 'role_created' => SabaiFramework_Model::KEY_TYPE_INT, 'role_updated' => SabaiFramework_Model::KEY_TYPE_INT);
    }

    protected function _getIdFieldName()
    {
        return 'role_name';
    }

    protected function _getSelectByIdQuery($id, $fields)
    {
        return sprintf(
            'SELECT %s FROM %ssystem_role WHERE role_name = %s',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            $this->_db->escapeString($id)
        );
    }

    protected function _getSelectByIdsQuery($ids, $fields)
    {
        return sprintf(
            'SELECT %s FROM %ssystem_role WHERE role_name IN (%s)',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            implode(', ', array_map(array($this->_db, 'escapeString'), $ids))
        );
    }

    protected function _getSelectByCriteriaQuery($criteriaStr, $fields)
    {
        return sprintf(
            'SELECT %1$s FROM %2$ssystem_role system_role WHERE %3$s',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            $criteriaStr
        );
    }

    protected function _getInsertQuery(&$values)
    {
        $values['role_created'] = time();
        $values['role_updated'] = 0;
        return sprintf('INSERT INTO %ssystem_role(role_name, role_title, role_permissions, role_created, role_updated) VALUES(%s, %s, %s, %d, %d)', $this->_db->getResourcePrefix(), $this->_db->escapeString($values['role_name']), $this->_db->escapeString($values['role_title']), $this->_db->escapeString(serialize($values['role_permissions'])), $values['role_created'], $values['role_updated']);
    }

    protected function _getUpdateQuery($id, $values)
    {
        $last_update = $values['role_updated'];
        $values['role_updated'] = time();
        return sprintf('UPDATE %ssystem_role SET role_title = %s, role_permissions = %s, role_updated = %d WHERE role_name = %s AND role_updated = %d', $this->_db->getResourcePrefix(), $this->_db->escapeString($values['role_title']), $this->_db->escapeString(serialize($values['role_permissions'])), $values['role_updated'], $this->_db->escapeString($id), $last_update);
    }

    protected function _getDeleteQuery($id)
    {
        return sprintf('DELETE FROM %1$ssystem_role WHERE role_name = %2$s', $this->_db->getResourcePrefix(), $this->_db->escapeString($id));
    }

    protected function _getUpdateByCriteriaQuery($criteriaStr, $sets)
    {
        $sets['role_updated'] = 'role_updated=' . time();
        return sprintf('UPDATE %ssystem_role system_role SET %s WHERE %s', $this->_db->getResourcePrefix(), implode(', ', $sets), $criteriaStr);
    }

    protected function _getDeleteByCriteriaQuery($criteriaStr)
    {
        return sprintf('DELETE system_role FROM %1$ssystem_role system_role WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }

    protected function _getCountByCriteriaQuery($criteriaStr)
    {
        return sprintf('SELECT COUNT(*) FROM %1$ssystem_role system_role WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }
}